//Создаем указатель на таймер
//генерации шагов для моторов робота
hw_timer_t * Timer = NULL;

// Объявляем переменные, хранящие текущее
// состояние уровня сигнала на GPIO шагов для моторов
//=======================================
// Флаг получения новой скорости
volatile bool newSpeedflag_ = false;
//+++++++++++++++++++++++++++++++++++++++
//Маска выключения высокого состояния шагов всех моторов
//Маски высокого состояния шагов для каждого мотора
//Маски подъема сигналов на GPIO шагов моторов
const uint32_t  STEP_mask_on_WEEL_LEFT_ = uint32_t(1) << GPIO_LEFT_WEEL_STEP;
const uint32_t  STEP_mask_on_WEEL_RIGHT_ = uint32_t(1) << GPIO_RIGHT_WEEL_STEP;
const uint32_t off_step = 0xFFFFFFFF ^  ( STEP_mask_on_WEEL_LEFT_ | STEP_mask_on_WEEL_RIGHT_);
//
////Количество шагов, которые нужно сделать
//int32_t  STEPS_counter_WEEL_LEFT_ = 0;
//int32_t  STEPS_counter_WEEL_RIGHT_ = 0;

//================================================
//================================================
uint32_t sost;
//Скорость для расчета длительности следующего шага
//Направление шагов

bool DIR_tec_WEEL_LEFT_ = DIR_LEFT_FORWARD;
bool DIR_tec_WEEL_RIGHT_ = DIR_RIGHT_FORWARD;

// Новое время - длительность шага в 10микСек
uint32_t newcounter_do_step_WEEL_LEFT_ = 100;
uint32_t newcounter_do_step_WEEL_RIGHT_ = 100;

//Установленное время - длительность шага в 10микСек
uint32_t  counter_do_step_WEEL_LEFT_ = 100;
uint32_t  counter_do_step_WEEL_RIGHT_ = 100;

//Пройденное время в 10х мк.сек

//Прошедшее время текущего шага в 10микСек
uint32_t counter_WEEL_LEFT_ = 0;
uint32_t counter_WEEL_RIGHT_ = 0;
bool old_sost = false;


//++++++++++++++++++++++++++++++++++++++++//
//==== ==//
const uint32_t half_step_ = 2; //пусть будет на 2 такте шага

uint32_t LONG_STEP_WEEL_LEFT_;
uint32_t LONG_STEP_WEEL_LEFT;
bool dir_STEP_WEEL_LEFT_;
bool dir_STEP_WEEL_LEFT;

bool True_speed_WEEL_LEFT_;
bool True_speed_WEEL_LEFT;

uint32_t LONG_STEP_WEEL_RIGHT_;
uint32_t LONG_STEP_WEEL_RIGHT;
bool dir_STEP_WEEL_RIGHT_;
bool dir_STEP_WEEL_RIGHT;

bool True_speed_WEEL_RIGHT_;
bool True_speed_WEEL_RIGHT;

bool True_speed_WEEL_RIGHT_Old = false;
bool True_speed_WEEL_LEFT_Old = false;


//++++++++++++++++++++++++++++++++++++++++//
void IRAM_ATTR core_timer() {
  //============================================
  //+++++++++++ обработка шагов ++++++++++++++++
  //============================================
  //Опустить шаг для всех моторов
  // Заменяем множество опускающих команд на
  sost = 0;

  if (STEPER_EN_level == MOTORS_ON)
  {
    if (counter_WEEL_RIGHT_ > counter_do_step_WEEL_RIGHT_)//Если шаг закончен
    {
      sost |= STEP_mask_on_WEEL_RIGHT_; //Поднять шаг -  пока только флаг
      //Счетчик длительности шага - обнуляем для начала нового шага
      counter_WEEL_RIGHT_ = 0;
      //Изменяем положение каретки
    }
    counter_WEEL_RIGHT_++; //Счетчик длительности шага

    if (counter_WEEL_LEFT_ > counter_do_step_WEEL_LEFT_)//Если шаг закончен
    {
      sost |= STEP_mask_on_WEEL_LEFT_; //Поднять шаг -  пока только флаг
      //Счетчик длительности шага - обнуляем для начала нового шага
      counter_WEEL_LEFT_ = 0;
    }
    counter_WEEL_LEFT_++; //Счетчик длительности шага
  }
  //Если шаг нужно делать
  //Опускаем сигналы шагов (пока только в переменной)
  //Поднимаем шаги для моторов, которым это нужно
  //Записываем значение с измененными битами шагов в регистр GPIO (0-31)
  if (sost != 0)
  {
    old_sost = true;
    REG_WRITE(GPIO_OUT_REG, (REG_READ(GPIO_OUT_REG) | sost));
  }
  // Если шаги делать не нужно, но нужно опустить
  // поднятые при прошлом вызове импульсы шагов
  else if (old_sost) {
    old_sost = false;
    // Опускаем все значения на шагов на 0
    REG_WRITE(GPIO_OUT_REG, (REG_READ(GPIO_OUT_REG) & off_step));
  }
  //*******************************************************************************

  if (sonarAVTO)
  {
    static uint32_t start_time = 0;
    static uint32_t stop_time = 0;
    static bool startFlag = false;
    static bool stopFlag = false;
    static uint32_t sonar_delay_time = 0;
    static uint32_t duration = 0;
    static uint32_t time_ = 0;
    static uint32_t flag_sonar = FLAG_SONAR_START1;
    if (flag_sonar == FLAG_SONAR_START1)
    {
      startFlag = false;
      stopFlag = false;
      // Переводим лимит из сантиметров в относительные величины (микросек.)
      duration = (Limit * 588) / 100;
      //Генерируем импульс
      digitalWrite(SONAR_TRIG, HIGH);
      flag_sonar = FLAG_SONAR_START2;

    }
    else if (flag_sonar == FLAG_SONAR_START2)
    {
      digitalWrite(SONAR_TRIG, LOW);
      //Ждем отражения импульса.
      // Пересчитываем время в расстояние (по скорости звуку).
      time_ = 0;
      stop_time = duration;
      flag_sonar = FLAG_SONAR_REGread;
    }
    else if (flag_sonar == FLAG_SONAR_REGread)
    {
      if ((time_ < duration) && (stopFlag == false))
      {

        registr_in = REG_READ(GPIO_IN_REG);

        if (startFlag == false)
        {
          if ((registr_in & long_mm_GPIO) != 0) {
            start_time = time_;
            startFlag = true;
          }
        }
        else
        {
          if ((registr_in & long_mm_GPIO) == 0)
          {
            stop_time = time_ - start_time;
            stopFlag = true;
          }
        }
        time_ ++;
      }
      else
      {
        flag_sonar = FLAG_SONAR_STOP;
        dist_mm  = (stop_time * 1000) / 588;
        sonar_delay_time = 0;
      }
    }
    else if (flag_sonar == FLAG_SONAR_STOP)
    {
      if (sonar_delay_time < 8000) //80 миллисекунд пауза
        sonar_delay_time++;
      else
        flag_sonar = FLAG_SONAR_START1;
    }
  }

  static bool startSig = false;
  if (handACTIV)
  {
    if (LongSig < 2000) //частота 50Гц
    {
      LongSig++;
      if ((LongSig > handLS) && startSig)
      {
        startSig = false;
        REG_WRITE(GPIO_OUT_REG, (REG_READ(GPIO_OUT_REG) & hand_maskSigOff));
        //     digitalWrite(2,LOW);
      }
    }
    else
    {
      REG_WRITE(GPIO_OUT_REG, (REG_READ(GPIO_OUT_REG) | hand_maskSigOn));
      //   digitalWrite(2,HIGH);
      startSig = true;
      LongSig = 0;
    }
  }
  else if (startSig) {
    digitalWrite(2, LOW);
    startSig = false;
  }
}


//+++++++++++++++++++++++++++++++++++++++++++++++//
//+++++++++++++++++++++++++++++++++++++++++++++++//
//Готовим состояния масок
// Создание таймеров, прикрепление к ним
// функций обработчиков прерываний
//+++++++++++++++++++++++++++++++++++++++++++++++//
void timer_setup()
{
  digitalWrite(GPIO_LEFT_WEEL_STEP, false);
  digitalWrite(GPIO_LEFT_WEEL_DIR, DIR_LEFT_FORWARD);
  DIR_tec_WEEL_LEFT_ = DIR_LEFT_FORWARD;

  digitalWrite(GPIO_RIGHT_WEEL_STEP, false);
  digitalWrite(GPIO_RIGHT_WEEL_DIR, DIR_RIGHT_FORWARD);
  DIR_tec_WEEL_RIGHT_ = DIR_RIGHT_FORWARD;


  // Создаем таймер
  Timer = timerBegin(2, 80, true);
  // Прикрепляем функциию обработчики
  timerAttachInterrupt(Timer, &core_timer, true);
  //Прерывание повторяется каждые 10 микросекунд
  timerAlarmWrite(Timer, 10, true);
  //Старт таймера, теперь прерывания будут генерироваться
  timerAlarmEnable(Timer);
}
